"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getMainFile(template) {
    switch (template) {
        case "vue-cli":
            return "src/main.js";
            break;
        case "angular-cli":
            return "src/main.ts";
            break;
        case "create-react-app-typescript":
            return "src/main.tsx";
            break;
        case "parcel":
        case "static":
            return "index.html";
            break;
        case "gatsby":
            return "src/pages/index.js";
            break;
        case "gridsome":
            return "src/pages/Index.vue";
            break;
        case "mdx-deck":
            return "deck.mdx";
            break;
        case "styleguidist":
        case "nuxt":
        case "next":
        case "apollo":
        case "reason":
        case "sapper":
        case "nest":
        case "vuepress":
        case "styleguidist":
            return "package.json";
            break;
        default:
            return "src/index.js";
            break;
    }
}
exports.getMainFile = getMainFile;
var SANDBOX_CONFIG = "sandbox.config.json";
function getTemplate(packageJSONPackage, modules) {
    var sandboxConfig = modules[SANDBOX_CONFIG] || modules["/" + SANDBOX_CONFIG];
    if (sandboxConfig && sandboxConfig.type !== "directory") {
        try {
            var config = JSON.parse(sandboxConfig.content);
            if (config.template) {
                return config.template;
            }
        }
        catch (e) { }
    }
    var _a = packageJSONPackage.dependencies, dependencies = _a === void 0 ? {} : _a, _b = packageJSONPackage.devDependencies, devDependencies = _b === void 0 ? {} : _b;
    var totalDependencies = Object.keys(dependencies).concat(Object.keys(devDependencies));
    var moduleNames = Object.keys(modules);
    var nuxt = ["nuxt", "nuxt-edge", "nuxt-ts", "nuxt-ts-edge"];
    if (totalDependencies.some(function (dep) { return nuxt.indexOf(dep) > -1; })) {
        return "nuxt";
    }
    if (totalDependencies.indexOf("next") > -1) {
        return "next";
    }
    var apollo = [
        "apollo-server",
        "apollo-server-express",
        "apollo-server-hapi",
        "apollo-server-koa",
        "apollo-server-lambda",
        "apollo-server-micro"
    ];
    if (totalDependencies.some(function (dep) { return apollo.indexOf(dep) > -1; })) {
        return "apollo";
    }
    if (totalDependencies.indexOf("mdx-deck") > -1) {
        return "mdx-deck";
    }
    if (totalDependencies.indexOf("gridsome") > -1) {
        return "gridsome";
    }
    if (totalDependencies.indexOf("vuepress") > -1) {
        return "vuepress";
    }
    if (totalDependencies.indexOf("ember-cli") > -1) {
        return "ember";
    }
    if (totalDependencies.indexOf("sapper") > -1) {
        return "sapper";
    }
    if (totalDependencies.indexOf("gatsby") > -1) {
        return "gatsby";
    }
    // CLIENT
    if (moduleNames.some(function (m) { return m.endsWith(".re"); })) {
        return "reason";
    }
    var parcel = ["parcel-bundler", "parcel"];
    if (totalDependencies.some(function (dep) { return parcel.indexOf(dep) > -1; })) {
        return "parcel";
    }
    var dojo = ["@dojo/core", "@dojo/framework"];
    if (totalDependencies.some(function (dep) { return dojo.indexOf(dep) > -1; })) {
        return "@dojo/cli-create-app";
    }
    if (totalDependencies.indexOf("@nestjs/core") > -1 ||
        totalDependencies.indexOf("@nestjs/common") > -1) {
        return "nest";
    }
    if (totalDependencies.indexOf("react-styleguidist") > -1) {
        return "styleguidist";
    }
    if (totalDependencies.indexOf("react-scripts") > -1) {
        return "create-react-app";
    }
    if (totalDependencies.indexOf("react-scripts-ts") > -1) {
        return "create-react-app-typescript";
    }
    if (totalDependencies.indexOf("@angular/core") > -1) {
        return "angular-cli";
    }
    if (totalDependencies.indexOf("preact-cli") > -1) {
        return "preact-cli";
    }
    if (totalDependencies.indexOf("svelte") > -1) {
        return "svelte";
    }
    if (totalDependencies.indexOf("vue") > -1) {
        return "vue-cli";
    }
    if (totalDependencies.indexOf("cx") > -1) {
        return "cxjs";
    }
    return undefined;
}
exports.getTemplate = getTemplate;
//# sourceMappingURL=templates.js.map